﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TinyPosEntity.Entity;

namespace TinyPosEntity.Service
{
    public class TransactionItemService
    {
        static TransactionItemService instance;
        public static TransactionItemService Instance { get { Init(); return instance; } }

        private static void Init()
        {
            if (instance == null)
                instance = new TransactionItemService();
        }

        public void Create(TransactionItem targetObject)
        {
            using (EntityContext context = new EntityContext())
            {
                context.TransactionItems.Add(targetObject);
                context.SaveChanges();
            }
        }

        public void Create(List<TransactionItem> targetObject)
        {
            using (EntityContext context = new EntityContext())
            {
                foreach (TransactionItem type in targetObject)
                {
                    context.TransactionItems.Add(type);
                }

                context.SaveChanges();
            }
        }

        public List<TransactionItem> Find(DateTime fromDateTime, DateTime toDateTime)
        {
            using (EntityContext context = new EntityContext())
            {
                var qry = from ti in context.TransactionItems
                          join t in context.Transactions
                            on ti.Transaction equals t
                          where (t.Timestamp >= fromDateTime && t.Timestamp <= toDateTime)
                          orderby t.Timestamp descending
                          select ti;

                if (qry.Count() < 1)
                    return null;

                return qry.ToList();
            }
        }
    }
}
