﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TinyPosEntity.Entity;

namespace TinyPosEntity.Service
{
    public class TransactionService
    {
        static TransactionService instance;
        public static TransactionService Instance { get { Init(); return instance; } }

        private static void Init()
        {
            if (instance == null)
                instance = new TransactionService();
        }

        public void Create(Transaction targetObject)
        {
            using (EntityContext context = new EntityContext())
            {
                context.Transactions.Add(targetObject);
                context.SaveChanges();
            }
        }

        public void Create(List<Transaction> targetObject)
        {
            using (EntityContext context = new EntityContext())
            {
                foreach (Transaction type in targetObject)
                {
                    context.Transactions.Add(type);
                }

                context.SaveChanges();
            }
        }

        public List<Transaction> Find(DateTime fromDateTime, DateTime toDateTime)
        {
            using (EntityContext context = new EntityContext())
            {
                var qry = from t in context.Transactions
                          where (t.Timestamp >= fromDateTime && t.Timestamp <= toDateTime)
                          orderby t.Timestamp descending
                          select t;

                if (qry.Count() < 1)
                    return null;

                return qry.ToList();
            }
        }
    }
}
